clear
%DATOS VARIOS
PD=[1.0 1.5 2 3 3.5] %paso adimensional muelle
ED=[0.074 0.074 0.074 0.074 0.074]

u=1.5; % velocidad del viento (norma UNE-EN 12975-2, m/s)
boltzmann=5.67e-08; %Constante de Stefan-Boltzmann
g_t=9.81; %Cte gravedad (m/s^2)
pi=3.1415926;
conc=0 %glicol

Long=[0:0.01:1.83]
casos=length(Long)-1

%DATOS INSTALACIN
A_a=2; %Area del colector
beta=45; % Angulo inclinacin del plano respecto a la horizontal ()
beta_rad=(beta*2*pi)/360;% pasamos el angulo a radianes
N=1; %Numero de vdrios del colector
N_t=9; % Nmero de tubos del panel absorbedor
W=1.105; %Anchura total placa absorbedora (m)
w=W/N_t; %Anchura placa absorbedora por tubo (m)
D_i=0.007; %Diametro interior de los tubos (m)
D_e=0.008;  %Diametro exterior de los tubos (m)
b=0.04; %Espesor captador (m)
delta_abs=0.0005; %Espesor de la placa del absorbedor (m)
delta_aisl=0.025; %Espesor del aislante del captador (m)
delta_tubo=0.0005; %Espesor del tubo (m)
g=0.0035; %Amplitud de la soldadura (m)
L=1.83; %Longitud tuberias%
tau_g=0.95; %Transmitancia de la cubierta transparente
alfa_abs=0.945; %Absortancia del absorbedor
e_g=0.88; %Emitancia cubierta transparente
e_abs=0.05; %Emitancia del absorbedor (vara entre rangos)
g=0.0035; %Ancho zona de contacto entre tubo y aleta (m)

%DATOS T Y CONDUCTIVIDADES TERMICAS
G=850; %Irradiacin solar incidente global (W/m^2)
%T_finn=90+273.15; %T entrada fluido (K)
T_a=20+273.15; %Temperatura ambiente (norma, K) 
%T_abs=75.9+273.15; %Temperatura del absorbedor (K)?????
k_aisl=0.045; %Cond. trmica del aislante (W/mK)
k_abs=209.3; %Conductividad trmica del absorbedor (W/mK)
g_d=6.6; %Conductividad de la soldadura (W/mK) Podemos tocarlo
g_d=3600;
k_tubo=372; %Cte conductividad del tubo (W/mK)

%DATOS FLUJO
q_min=120; %gasto msico minimo total (Kg/h*m^2)
f_masicomin=(q_min*A_a)/N_t/3600; %Flujo msico mnimo por tubo (Kg/s)

%BUCLE PARA EL CLCULO DE PRDIDAS
h_w=5.7+(3.8*u); % Coef. transf. q. debido al viento en la cubierta (W7m^2K)
C=520*(1-0.000051*(beta_rad^2)); %parametro de la ecuacion de perdidas de klein
f=((9/h_w)-(30/h_w^2))*(T_a/316.9)*(1+0.091*N); %Relacin entre la resistencia trmica externa e interna
U_be=k_aisl/delta_aisl; %Coef. perdidas del fondo y laterales del colector


S=G*(tau_g*alfa_abs); %Energa solar absorbida por el colector (W/m^2)

%BUCLE PARAMETROS DE FLUJO
T_finn=[17.5 20 40 55 60 70 80 90]+273.15
Re_c=-128.28+186.883.*PD; %%Reynolds critico transicin muelles (AGUSTIN)

n=1
for n=1:size(PD,2)
k=1
for k=1:size(T_finn,2)
T_fin(k,1,n)=T_finn(k)
j=2
for i=1:casos
T_abs(1)=30+273.14
T_abs(2)=300
while abs((T_abs(j)-T_abs(j-1)))>0.01    
U_t1(k,i,n)=(N/((C/T_abs(j))*((T_abs(j)-T_a)/(N+f))^0.252)+(1/h_w))^-1;    
U_t2(k,i,n)=boltzmann*(T_abs(j)+T_a)*(T_abs(j)^2+T_a^2);
U_t3(k,i,n)=(e_abs+(0.0425*N*(1-e_abs)))^-1+(((2*N)+f-1)/e_g)-N;
U_t(k,i,n)=U_t1(k,i,n)+(U_t2(k,i,n)/U_t3(k,i,n));
U_l(k,i,n)=U_be+U_t(k,i,n); %Coef. global de prdidas de calor del captador con T uniforme de absorbedor
    
x(k,i,n)=Long(i)+(Long(i+1)-Long(i))/2;
A(k,i,n)=W*(Long(i+1)-Long(i))/9; 

%%%%PROPIEDADES GLICOL
BB(k,i,n)=71.639163222-0.66981698459*T_fin(k,i,n)+0.0019150513174*T_fin(k,i,n)^2-0.0000018587687783*T_fin(k,i,n)^3;
CC(k,i,n)=0.27019804611-0.0012299975866*T_fin(k,i,n)+0.0000015045427918*T_fin(k,i,n)^2;
mu(k,i,n)=exp(BB(k,i,n)+CC(k,i,n)*conc);% Viscosidad fluido conductor (Pa*s)

DD(k,i,n)=3.8649883866-0.023691954902*conc-0.00011278222908*conc^2;
EE(k,i,n)=0.001023655712+0.000056633876714*conc;
c_f(k,i,n)=(DD(k,i,n)+EE(k,i,n)*T_fin(k,i,n)).*1000;%% Cp fluido conductor (j/kgK) 

FF(k,i,n)=875.54696219+2.151387542*conc;
GG(k,i,n)=1.1191046068-0.0007599907262*conc-0.000049236799989*conc^2;
HH(k,i,n)=-0.002377960199-0.0000091377252136*conc+0.00000010872237562*conc^2;
rof(k,i,n)=FF(k,i,n)+GG(k,i,n)*T_fin(k,i,n)+HH(k,i,n)*T_fin(k,i,n)^2;%Densidad fluido conductor (kg/m^3)

II(k,i,n)=-0.78595253278+0.015561899561*conc-0.000048933521576*conc^2;
JJ(k,i,n)=0.0076866167254-0.0001155974176*conc+0.0000003660336083*conc^2;
KK(k,i,n)=-0.0000099976810237+0.00000014560615474*conc-4.5879383578E-10*conc^2;
k_f(k,i,n)=II(k,i,n)+JJ(k,i,n)*T_fin(k,i,n)+KK(k,i,n)*T_fin(k,i,n)^2; %Cond trmica fluido

%%%%PROPIEDADES AGUA (DENSIDaAD Y CALOR ESP) NORMA UNE
%rof(k,i)=999.85+(6.187e-02*T_fin(k,i))-(7.654e-03*T_fin(k,i)^2)+(3.974e-05*T_fin(k,i)^3)-(1.11e-07*T_fin(k,i)^4);
%c_f(k,i)=1000*(4.217-3.358e-03*T_fin(k,i)+1.089e-04*T_fin(k,i)^2-1.675e-06*T_fin(k,i)^3+1.309e-08*T_fin(k,i)^4-3.884e-11*T_fin(k,i)^5);

%%%%PROPIEDADES AGUA AGUSTIN
%mu(k,i)=0.0000001*T_fin(k,i)^2-0.00003*T_fin(k,i)+0.0015;
%c_f(k,i)=0.0099*T_fin(k,i)^2-0.8087*T_fin(k,i)+4197;
%k_f(k,i)=-0.000008*T_fin(k,i)^2+0.0019*T_fin(k,i)+0.5641;
%rof(k,i)=-0.0033*T_fin(k,i)^2-0.1063*T_fin(k,i)+1001.6;

%%%%%%%%
Pr(k,i,n)=(mu(k,i,n)*c_f(k,i,n))/k_f(k,i,n); %N Prandtl
Re(k,i,n)=(4*f_masicomin)/(pi*D_i*mu(k,i,n)); %Valor N Reynolds para caudal mnimo establecido
Gz(k,i,n)=(pi/4)*(x(k,i,n)/(D_i*Re(k,i,n)*Pr(k,i,n)))^-1; %Valores N Graetz dependern de la posicin x del fluido en el tubo
Gz_lim(k,i,n)=(pi/4)*(x(k,i,n)/(D_i*Re_c(n)*Pr(k,i,n)))^-1; %Valores N Graetz para Reynolds critico
Nu_lam_lim(k,i,n)=0.9242*(pi/(4*Gz_lim(k,i,n)))^-0.37591; %%Nusselt laminar para Reynolds critico
Nu_lam(k,i,n)=0.9242*(pi/(4*Gz(k,i,n)))^-0.37591; %%Nusselt laminar muelles (AGUSTIN)
Nu_tur(k,i,n)=0.158*PD(n)^-0.362*ED(n)^0.107*Re(k,i,n)^0.724*Pr(k,i,n)^0.370;  %%Nusselt turbulento muelles (AGUSTIN);
Nu_tur_lim(k,i,n)=0.158*PD(n)^-0.362*ED(n)^0.107*1200^0.724*Pr(k,i,n)^0.370;%%Nusselt turbulento para Reynolds 1200
Nu_tra(k,i,n)=Nu_lam_lim(k,i,n)+((Re(k,i,n)-Re_c(n))/(1200-Re_c(n)))*(Nu_tur_lim(k,i,n)-Nu_lam_lim(k,i,n)); %%Nusselt transicion (AGUSTIN)

if Re(k,i,n)<Re_c(n)
    Nu(k,i,n)=Nu_lam(k,i,n); 
elseif Re(k,i,n)>Re_c(n) & Re(k,i,n)<1200
    Nu(k,i,n)=Nu_tra(k,i,n);
else
    Nu(k,i,n)=Nu_tur(k,i,n);
end




h_fi(k,i,n)=Nu(k,i,n)*k_f(k,i,n)/D_i; %Coeficiente de transferencia de calor del fluido para qmin (W/m 2K)

%BUCLE EXPRESIONES EISENMANN
mu_d(k,i,n)=1/2*((pi*D_i)-g)*sqrt((Nu(k,i,n)*k_f(k,i,n))/(D_i*k_tubo*delta_tubo)); %Parametro tipo Biot
nu_d(k,i,n)=tanh(mu_d(k,i,n))/mu_d(k,i,n); %Eficiencia de aleta del tubo
s_inf(k,i,n)=((pi*nu_d(k,i,n))/2)+(((1+nu_d(k,i,n))*g)/(2*D_i)); %Factor de forma
c_e(k,i,n)=(g_d*g)/(2*k_f(k,i,n)*Nu(k,i,n)); %Parmetro de conductancia en el contacto entre aleta y tubo
k_gf(k,i,n)=(1/c_e(k,i,n)+1/s_inf(k,i,n))^-1*((2*k_f(k,i,n)*Nu(k,i,n))/(pi*D_i)); %Coef. transm. q entre fluido y zona de contacto (W/m 2K)

%CALCULOS F, F' Y F_r
m(k,i,n)=sqrt(U_l(k,i,n)/(k_abs*delta_abs)); %Parametro para el calculo de F
%F(k,i,n)=(tanh(m(k,i,n)*(w-D_e)/2))/(m(k,i,n)*(w-D_e)/2); %Hobbi
F(k,i,n)=(tanh((m(k,i,n)/2)*(w-g)))/((m(k,i,n)/2)*(w-g)); %Eisenmann
F_primae(k,i,n)=(w*((1/((w-g)*F(k,i,n)+g))+(U_l(k,i,n)/(k_gf(k,i,n)*pi*D_i))))^-1; %Eisenmann
F_primah(k,i,n)=(1/U_l(k,i,n))/(w*(1/(U_l(k,i,n)*(D_e+(w-D_e)*F(k,i,n)))+(1/g_d)+1/(pi*D_i*h_fi(k,i,n)))); %Hobbi

%F_r(k,i)=((f_masicomin*c_f(k,i))/(A(k,i)*U_l(k,i)))*(1-exp(-(F_primah(k,i)*U_l(k,i)*A(k,i))/(f_masicomin*c_f(k,i)))); Hobbi %Al calcular Factor remocin, para ambas expr (F_r, F_rmax) emplea F' para qmin y por la expresin de Hobbi
F_r(k,i,n)=((f_masicomin*c_f(k,i,n))/(A(k,i,n)*U_l(k,i,n)))*(1-exp(-(F_primae(k,i,n)*U_l(k,i,n)*A(k,i,n))/(f_masicomin*c_f(k,i,n)))); %Eisenmann %Al calcular Factor remocin, para ambas expr (F_r, F_rmax) emplea F' para qmin y por la expresin de Hobbi



%OBTENCIN RENDIMIENTO, TEMPERATURAS, ETC

Q_util(k,i,n)=A(k,i,n)*F_r(k,i,n)*(S-(U_l(k,i,n)*(T_fin(k,i,n)-T_a)));
T_abs_cal(k,i,n)=T_fin(k,i,n)+(Q_util(k,i,n)/(A(k,i,n)*U_l(k,i,n)*F_r(k,i,n)))*(1-F_r(k,i,n)); %Temperatura absoluta del absorbedor para qmin (K)
T_fout(k,i,n)=T_fin(k,i,n)+(Q_util(k,i,n)/(f_masicomin*c_f(k,i,n))); %Temperatura de salida qmin
 
j=j+1;
T_abs(j)=T_abs_cal(k,i,n);
end

j=2;
%T_abs(k,i)=T_abs_cal(k,i)
T_fin(k,i+1,n)=T_fout(k,i,n);
end
end


for k=1:size(T_finn,2)
eficiencia(k,n)=sum(Q_util(k,:,n))/(W*L/9*G); %Eficiencia de colector con caudal mnimo establecido
T_out(k,n)=T_fout(k,casos,n);
T_absorbedor(k,n)=mean(T_abs_cal(k,:,n));
t_m(k,n)=(T_finn(k)+T_fout(k,casos,n))/2; %Temperatura mkzedia del fluido de transferenciad de calor (K)
T_m(k,n)=(t_m(k,n)-T_a)/G; %(Tm*) Tadimensionel Diferencia de T absoluta reducida (m^2K/W)
EFI_SOL_1(k,n)=0.787-4.653.*T_m(k,n);
EFI_SOL_2(k,n)=0.799-3.4.*T_m(k,n)-0.026.*G.*T_m(k,n)^2;
end
end

for l=1:size(PD,2)
DATOS(:,:,l)=[T_finn' T_out(:,l) T_absorbedor(:,l) T_m(:,l) eficiencia(:,l) EFI_SOL_1(:,l) EFI_SOL_2(:,l)]
end

figure(1)
plot(DATOS(:,4,1),DATOS(:,5,1),'ko',DATOS(:,4,2),DATOS(:,5,2),'k<',DATOS(:,4,3),DATOS(:,5,3),'ks',DATOS(:,4,4),DATOS(:,5,4),'kd',...
    DATOS(:,4,4),DATOS(:,5,4),'kx')

P=polyfit(DATOS(:,4),DATOS(:,5),1)
A=polyfit(DATOS(:,4),DATOS(:,5),2)

EFI_CAL_1=P(2)+P(1).*DATOS(:,4);
EFI_CAL_2=A(3)+A(2).*DATOS(:,4)+(A(1)/G).*DATOS(:,4).^2;



